SystemOrganization addCategory: #GhostProxiesTests!
SystemOrganization addCategory: 'GhostProxiesTests-Mocks'!
SystemOrganization addCategory: 'GhostProxiesTests-SimpleForwarderExample'!

Object subclass: #GHUser
	instanceVariableNames: 'username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests-Mocks'!

!GHUser class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/9/2012 11:06'!
named: aName
	^ self new username: aName! !

!GHUser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 12:05'!
username ^ username! !

!GHUser methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 2/9/2012 11:07'!
username: anObject
	username := anObject! !

GHUser subclass: #GHUserSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests-Mocks'!

TestCase subclass: #GHSimpleForwarderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GhostProxiesTests-SimpleForwarderExample'!

!GHSimpleForwarderTest methodsFor: 'running' stamp: 'MarianoMartinezPeck 11/20/2012 19:31'!
setUp
	GHProxyTrap initialize.   ! !

!GHSimpleForwarderTest methodsFor: 'tests - handler answers' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testHandlerAnswerDebugging
	| proxy |
	proxy := GHTargetBasedProxy createProxyFor: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy printString = 'This is the print of a proxy'! !

!GHSimpleForwarderTest methodsFor: 'tests - proxy answers' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testProxyAnswerDebugging
	| proxy |
	proxy := GHTargetBasedProxy createProxyFor: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy isProxy! !

!GHSimpleForwarderTest methodsFor: 'tests - classes' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testSimpleForwardingForClassesToClass
    | aProxy aUser |
       aUser := GHUser named: 'Kurt'.
	[aProxy := GHTargetBasedClassProxy createProxyAndReplace: GHUser handler: GHSimpleForwarderProxyHandler new. 
       self assert:  GHUser name equals: #GHUser. 
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests - classes' stamp: 'DamienPollet 9/5/2014 15:09'!
testSimpleForwardingForClassesToInstance
    | aProxy aUser |
       aUser := GHUser named: 'Kurt'.
       
	[ aProxy := GHTargetBasedClassProxy
			createProxyAndReplace: GHUser
			handler: GHSimpleForwarderProxyHandler new. 
		self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests - classes' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testSimpleForwardingForClassesToSubclass
    | aProxy aUser |
       aUser := GHUser named: 'Kurt'.
	[aProxy := GHTargetBasedClassProxy createProxyAndReplace: GHUser handler: GHSimpleForwarderProxyHandler new. 
	self assert:  GHUserSubclass name equals: #GHUserSubclass. 
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests - classes' stamp: 'DamienPollet 9/5/2014 15:29'!
testSimpleForwardingForClassesToSubclassInstance
    | aProxy aUser |
       aUser := GHUserSubclass named: 'Kurt'.

	[ aProxy := GHTargetBasedClassProxy
			createProxyAndReplace: GHUser
			handler: GHSimpleForwarderProxyHandler new. 
		self assert: aUser username equals: 'Kurt'.
	] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests - methods' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testSimpleForwardingForMethodUsingBecome
       | aProxy aUser method |
       aUser := GHUser named: 'Kurt'.
       method := GHUser methodDict at: #username.
       [aProxy := GHTargetBasedProxy createProxyAndReplace: method handler: GHSimpleForwarderProxyHandler new. 
       self assert: aProxy getSource equals: 'username ^ username'. 
       self assert: aUser username equals: 'Kurt'.
	 ] ensure: [ aProxy uninstall ]! !

!GHSimpleForwarderTest methodsFor: 'tests - regular objects' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testSimpleForwardingForRegularObject
	| proxy |
	proxy := GHTargetBasedProxy createProxyFor: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !

!GHSimpleForwarderTest methodsFor: 'tests - regular objects' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testSimpleForwardingForRegularObject2
	| proxy |
	proxy := GHTargetBasedProxy createProxyFor: (GHUser named: 'mariano') handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy username = 'mariano'.! !

!GHSimpleForwarderTest methodsFor: 'tests - regular objects' stamp: 'MarianoMartinezPeck 2/20/2012 11:59'!
testSimpleForwardingForRegularObjectWithBecome
	| proxy |
	proxy := GHTargetBasedProxy createProxyAndReplace: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !

!GHSimpleForwarderTest methodsFor: 'tests - regular objects' stamp: 'MarianoMartinezPeck 11/7/2012 11:26'!
testSimpleForwardingNoTargetLeak
	| proxy |
	proxy := GHTargetBasedProxy createProxyFor: (Point x: 3 y: 4) handler: GHSimpleForwarderProxyHandler new. 
	self assert: proxy x equals: 3. 
	self assert: proxy y equals: 4.! !
